org.vertx.java.core.streams

## Interface WriteStream

All Known Subinterfaces:
  HttpClientRequest

All Known Implementing Classes:
  HttpServerResponse, NetSocket, ServerWebSocket, SockJSSocket, WebSocket

    public interface WriteStream

Represents a stream of data that can be written to

Any class that implements this interface can be used by a `Pump` to pump data from a `ReadStream` to it.

### Method Summary

Methods
`void` `drainHandler(Handler<java.lang.Void> handler)` Set a drain handler on the stream.
`void` `exceptionHandler(Handler<java.lang.Exception> handler)` Set an exception handler on the stream
`void` `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
`void` `writeBuffer(Buffer data)` Write some data to the stream.
`boolean` `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

### Method Detail

#### writeBuffer

    void writeBuffer(Buffer data)

Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `writeQueueFull()` method before writing. This is done automatically if using a `Pump`.

#### setWriteQueueMaxSize

    void setWriteQueueMaxSize(int maxSize)

Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` bytes in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

#### writeQueueFull

    boolean writeQueueFull()

This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

#### drainHandler

    void drainHandler(Handler<java.lang.Void> handler)

Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue has been reduced to maxSize / 2. See `Pump` for an example of this being used.

#### exceptionHandler

    void exceptionHandler(Handler<java.lang.Exception> handler)

Set an exception handler on the stream